//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Amzi"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
                AnsiString BD,IS,S;
                        IS="database.pro";//  
                        BD=IS.SubString(1,IS.LastDelimiter("."))+"xpl";//  
                        Memo1->Lines->Clear();
                        Memo1->Lines->LoadFromFile(IS);// 
                        if(FileExists(BD))//   
                        {
                                LSEngine1->InitLS(BD);
                                LSEngine1->LoadXPL(BD);//  
                        }else{
                                BD="clear.xpl";//   
                                LSEngine1->InitLS(BD);
                                LSEngine1->LoadXPL(BD);// 
                                for(int i=0;i<Memo1->Lines->Count;i++)
                                {
                                        S=Memo1->Lines->Strings[i];
                                        if(S!="")
                                        {
                                                LSEngine1->AssertzPStr(S);//    
                                        }
                                }
                        }

}
//---------------------------------------------------------------------------
void TForm1::ExecQuery(AnsiString query) {
        TTerm t;//   
        if(LSEngine1->CallPStr(t,query))//    Edit1 
        {
                do{//   
                if (LSEngine1->GetArity(t) == 1)
                                Memo2->Lines->Add(" " +LSEngine1->GetPStrArg(t, 1) );
                if (LSEngine1->GetArity(t) == 2)
                                Memo2->Lines->Add(" " + LSEngine1->GetPStrArg(t, 1) + " " + LSEngine1->GetPStrArg(t, 2));
                }while(LSEngine1->Redo());//  
        }else{
                ShowMessage("  ");
        }
};
//---------------------------------------------------------------------------
void TForm1::AddTrem(AnsiString term) {
        TTerm t;
        LSEngine1->PStrToTerm(t,term);//   
        LSEngine1->Asserta(t);//  
        Memo1->Lines->Add(term);//  

}
//---------------------------------------------------------------------------
void TForm1::DelTrem(AnsiString term) {
        TTerm t;
        for(int i=0;i<Memo1->Lines->Count;i++)//  
        {
                if(term==Memo1->Lines->Strings[i])
                {
                        Memo1->Lines->Delete(i);//  
                }
        }
        LSEngine1->PStrToTerm(t,term);//   
        LSEngine1->Retract(t);//

}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
        Memo2->Lines->Clear();
        switch (RadioGroup1->ItemIndex) {
                case 0:
                        Memo2->Lines->Add(" :");
                        ExecQuery("man(X).");
                        break;
                case 1:
                        Memo2->Lines->Add(" :");
                        ExecQuery("woman(X).");
                        break;
                default:
                        ShowMessage(" ");
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn6Click(TObject *Sender)
{
        Memo2->Lines->Clear();
        Memo2->Lines->Add(" :");
        ExecQuery("married(X,Y).");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
        if (LabeledEdit1->Text != "") {
        switch (RadioGroup1->ItemIndex) {
                case 0:
                        AddTrem("man('"+LabeledEdit1->Text+"').");
                        break;
                case 1:
                        AddTrem("woman('"+LabeledEdit1->Text+"').");
                        break;
                default:
                        ShowMessage(" ");
        }
        } else
                ShowMessage(" ");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
        if (LabeledEdit1->Text != "") {
        switch (RadioGroup1->ItemIndex) {
                case 0:
                        DelTrem("man('"+LabeledEdit1->Text+"').");
                        break;
                case 1:
                        DelTrem("woman('"+LabeledEdit1->Text+"').");
                        break;
                default:
                        ShowMessage(" ");
        }
        } else
                ShowMessage(" ");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
        if (LabeledEdit3->Text == "") {
                ShowMessage("  ");
                return;
        }
         if (LabeledEdit3->Text == "") {
                ShowMessage("  ");
                return;
        }
        AddTrem("married('"+LabeledEdit3->Text+"','"+LabeledEdit2->Text+"').");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
        if (LabeledEdit3->Text == "") {
                ShowMessage("  ");
                return;
        }
         if (LabeledEdit3->Text == "") {
                ShowMessage("  ");
                return;
        }
        DelTrem("married('"+LabeledEdit3->Text+"','"+LabeledEdit2->Text+"').");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn8Click(TObject *Sender)
{
        Memo2->Lines->Clear();
        TTerm t;//   
        if(LSEngine1->CallPStr(t,"suprug('"+LabeledEdit4->Text+"',X)."))//    Edit1 
        {
                do{//   
                        if (LSEngine1->GetArity(t) == 2)
                                Memo2->Lines->Add(" "+LSEngine1->GetPStrArg(t, 1) + "  " + LSEngine1->GetPStrArg(t, 2));
                }while(LSEngine1->Redo());//  
        }else{
                ShowMessage("  ");
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        Memo1->Lines->SaveToFile("database.pro");
}
//---------------------------------------------------------------------------

